Loading...
Searching...
No Matches
latrsd: Triangular solve with modified diagonal; used by trevc
Dense LA » Eigenvalues » Non-symmetric eigenvalues » Auxiliary routines

## Functions

magma_int_t | magma_clatrsd (magma_uplo_t uplo, magma_trans_t trans, magma_diag_t diag, magma_bool_t normin, magma_int_t n, const magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex lambda, magmaFloatComplex *x, float *scale, float *cnorm, magma_int_t *info)
| CLATRSD solves one of the triangular systems with modified diagonal (A - lambda*I) * x = s*b, (A - lambda*I)**T * x = s*b, or (A - lambda*I)**H * x = s*b, with scaling to prevent overflow.
magma_int_t | magma_zlatrsd (magma_uplo_t uplo, magma_trans_t trans, magma_diag_t diag, magma_bool_t normin, magma_int_t n, const magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex lambda, magmaDoubleComplex *x, double *scale, double *cnorm, magma_int_t *info)
| ZLATRSD solves one of the triangular systems with modified diagonal (A - lambda*I) * x = s*b, (A - lambda*I)**T * x = s*b, or (A - lambda*I)**H * x = s*b, with scaling to prevent overflow.

## Detailed Description

## Function Documentation

## magma_clatrsd()

magma_int_t magma_clatrsd | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_diag_t | diag,
|  | magma_bool_t | normin,
|  | magma_int_t | n,
|  | const magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex | lambda,
|  | magmaFloatComplex * | x,
|  | float * | scale,
|  | float * | cnorm,
|  | magma_int_t * | info )

CLATRSD solves one of the triangular systems with modified diagonal (A - lambda*I) * x = s*b, (A - lambda*I)**T * x = s*b, or (A - lambda*I)**H * x = s*b, with scaling to prevent overflow.

Here A is an upper or lower triangular matrix, A**T denotes the transpose of A, A**H denotes the conjugate transpose of A, x and b are n-element vectors, and s is a scaling factor, usually less than or equal to 1, chosen so that the components of x will be less than the overflow threshold. If the unscaled problem will not cause overflow, the Level 2 BLAS routine CTRSV is called. If the matrix A is singular (A(j,j) = 0 for some j), then s is set to 0 and a non-trivial solution to A*x = 0 is returned.

This version subtracts lambda from the diagonal, for use in ctrevc to compute eigenvectors. It does not modify A during the computation.

Parameters

  [in]

  uplo

  magma_uplo_t Specifies whether the matrix A is upper or lower triangular.
  - = MagmaUpper: Upper triangular
  - = MagmaLower: Lower triangular

  [in]

  trans

  magma_trans_t Specifies the operation applied to A.
  - = MagmaNoTrans: Solve (A - lambda*I) * x = s*b (No transpose)
  - = MagmaTrans: Solve (A - lambda*I)**T * x = s*b (Transpose)
  - = MagmaConjTrans: Solve (A - lambda*I)**H * x = s*b (Conjugate transpose)

  [in]

  diag

  magma_diag_t Specifies whether or not the matrix A is unit triangular.
  - = MagmaNonUnit: Non-unit triangular
  - = MagmaUnit: Unit triangular

  [in]

  normin

  magma_bool_t Specifies whether CNORM has been set or not.
  - = MagmaTrue: CNORM contains the column norms on entry
  - = MagmaFalse: CNORM is not set on entry. On exit, the norms will be computed and stored in CNORM.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in]

  A

  COMPLEX array, dimension (LDA,N) The triangular matrix A. If UPLO = MagmaUpper, the leading n by n upper triangular part of the array A contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading n by n lower triangular part of the array A contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1.

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max (1,N).
  [in] | lambda | COMPLEX Eigenvalue to subtract from diagonal of A.
  [in,out] | x | COMPLEX array, dimension (N) On entry, the right hand side b of the triangular system. On exit, X is overwritten by the solution vector x.
  [out] | scale | REAL The scaling factor s for the triangular system A * x = s*b, A**T * x = s*b, or A**H * x = s*b. If SCALE = 0, the matrix A is singular or badly scaled, and the vector x is an exact or approximate solution to A*x = 0.

  [in,out]

  cnorm

  (input or output) REAL array, dimension (N)
  - If NORMIN = MagmaTrue, CNORM is an input argument and CNORM(j) contains the norm of the off-diagonal part of the j-th column of A. If TRANS = MagmaNoTrans, CNORM(j) must be greater than or equal to the infinity-norm, and if TRANS = MagmaTrans or MagmaConjTrans, CNORM(j) must be greater than or equal to the 1-norm.
  - If NORMIN = MagmaFalse, CNORM is an output argument and CNORM(j) returns the 1-norm of the offdiagonal part of the j-th column of A.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -k, the k-th argument had an illegal value

## Further Details

A rough bound on x is computed; if that is less than overflow, CTRSV is called, otherwise, specific code is used which checks for possible overflow or divide-by-zero at every operation.

A columnwise scheme is used for solving A*x = b. The basic algorithm if A is lower triangular is

     x[1:n] := b[1:n]
     for j = 1, ..., n
          x(j) := x(j) / A(j,j)
          x[j+1:n] := x[j+1:n] - x(j) * A[j+1:n,j]
     end

Define bounds on the components of x after j iterations of the loop: M(j) = bound on x[1:j] G(j) = bound on x[j+1:n] Initially, let M(0) = 0 and G(0) = max{x(i), i=1,...,n}.

Then for iteration j+1 we have M(j+1) <= G(j) / | A(j+1,j+1) | G(j+1) <= G(j) + M(j+1) * | A[j+2:n,j+1] | <= G(j) ( 1 + CNORM(j+1) / | A(j+1,j+1) | )

where CNORM(j+1) is greater than or equal to the infinity-norm of column j+1 of A, not counting the diagonal. Hence

G(j) <= G(0) product ( 1 + CNORM(i) / | A(i,i) | ) 1 <= i <= j and

|x(j)| <= ( G(0) / |A(j,j)| ) product ( 1 + CNORM(i) / |A(i,i)| ) 1 <= i < j

Since |x(j)| <= M(j), we use the Level 2 BLAS routine CTRSV if the reciprocal of the largest M(j), j=1,..,n, is larger than max(underflow, 1/overflow).

The bound on x(j) is also used to determine when a step in the columnwise method can be performed without fear of overflow. If the computed bound is greater than a large constant, x is scaled to prevent overflow, but if the bound overflows, x is set to 0, x(j) to 1, and scale to 0, and a non-trivial solution to A*x = 0 is found.

Similarly, a row-wise scheme is used to solve A**T *x = b or A**H *x = b. The basic algorithm for upper triangular A is:

     for j = 1, ..., n
          x(j) := ( b(j) - A[1:j-1,j]' * x[1:j-1] ) / A(j,j)
     end

We simultaneously compute two bounds G(j) = bound on ( b(i) - A[1:i-1,i]' * x[1:i-1] ), 1 <= i <= j M(j) = bound on x(i), 1 <= i <= j

The initial values are G(0) = 0, M(0) = max{b(i), i=1,..,n}, and we add the constraint G(j) >= G(j-1) and M(j) >= M(j-1) for j >= 1. Then the bound on x(j) is

     M(j) <= M(j-1) * ( 1 + CNORM(j) ) / | A(j,j) |

          <= M(0) * product      ( ( 1 + CNORM(i) ) / |A(i,i)| )
                    1 <= i <= j

and we can safely call CTRSV if 1/M(n) and 1/G(n) are both greater than max(underflow, 1/overflow).

## magma_zlatrsd()

magma_int_t magma_zlatrsd | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_diag_t | diag,
|  | magma_bool_t | normin,
|  | magma_int_t | n,
|  | const magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex | lambda,
|  | magmaDoubleComplex * | x,
|  | double * | scale,
|  | double * | cnorm,
|  | magma_int_t * | info )

ZLATRSD solves one of the triangular systems with modified diagonal (A - lambda*I) * x = s*b, (A - lambda*I)**T * x = s*b, or (A - lambda*I)**H * x = s*b, with scaling to prevent overflow.

Here A is an upper or lower triangular matrix, A**T denotes the transpose of A, A**H denotes the conjugate transpose of A, x and b are n-element vectors, and s is a scaling factor, usually less than or equal to 1, chosen so that the components of x will be less than the overflow threshold. If the unscaled problem will not cause overflow, the Level 2 BLAS routine ZTRSV is called. If the matrix A is singular (A(j,j) = 0 for some j), then s is set to 0 and a non-trivial solution to A*x = 0 is returned.

This version subtracts lambda from the diagonal, for use in ztrevc to compute eigenvectors. It does not modify A during the computation.

Parameters

  [in]

  uplo

  magma_uplo_t Specifies whether the matrix A is upper or lower triangular.
  - = MagmaUpper: Upper triangular
  - = MagmaLower: Lower triangular

  [in]

  trans

  magma_trans_t Specifies the operation applied to A.
  - = MagmaNoTrans: Solve (A - lambda*I) * x = s*b (No transpose)
  - = MagmaTrans: Solve (A - lambda*I)**T * x = s*b (Transpose)
  - = MagmaConjTrans: Solve (A - lambda*I)**H * x = s*b (Conjugate transpose)

  [in]

  diag

  magma_diag_t Specifies whether or not the matrix A is unit triangular.
  - = MagmaNonUnit: Non-unit triangular
  - = MagmaUnit: Unit triangular

  [in]

  normin

  magma_bool_t Specifies whether CNORM has been set or not.
  - = MagmaTrue: CNORM contains the column norms on entry
  - = MagmaFalse: CNORM is not set on entry. On exit, the norms will be computed and stored in CNORM.

  [in] | n | INTEGER The order of the matrix A. N >= 0.

  [in]

  A

  COMPLEX_16 array, dimension (LDA,N) The triangular matrix A. If UPLO = MagmaUpper, the leading n by n upper triangular part of the array A contains the upper triangular matrix, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading n by n lower triangular part of the array A contains the lower triangular matrix, and the strictly upper triangular part of A is not referenced. If DIAG = MagmaUnit, the diagonal elements of A are also not referenced and are assumed to be 1.

  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max (1,N).
  [in] | lambda | COMPLEX_16 Eigenvalue to subtract from diagonal of A.
  [in,out] | x | COMPLEX_16 array, dimension (N) On entry, the right hand side b of the triangular system. On exit, X is overwritten by the solution vector x.
  [out] | scale | DOUBLE PRECISION The scaling factor s for the triangular system A * x = s*b, A**T * x = s*b, or A**H * x = s*b. If SCALE = 0, the matrix A is singular or badly scaled, and the vector x is an exact or approximate solution to A*x = 0.

  [in,out]

  cnorm

  (input or output) DOUBLE PRECISION array, dimension (N)
  - If NORMIN = MagmaTrue, CNORM is an input argument and CNORM(j) contains the norm of the off-diagonal part of the j-th column of A. If TRANS = MagmaNoTrans, CNORM(j) must be greater than or equal to the infinity-norm, and if TRANS = MagmaTrans or MagmaConjTrans, CNORM(j) must be greater than or equal to the 1-norm.
  - If NORMIN = MagmaFalse, CNORM is an output argument and CNORM(j) returns the 1-norm of the offdiagonal part of the j-th column of A.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -k, the k-th argument had an illegal value

## Further Details

A rough bound on x is computed; if that is less than overflow, ZTRSV is called, otherwise, specific code is used which checks for possible overflow or divide-by-zero at every operation.

A columnwise scheme is used for solving A*x = b. The basic algorithm if A is lower triangular is

     x[1:n] := b[1:n]
     for j = 1, ..., n
          x(j) := x(j) / A(j,j)
          x[j+1:n] := x[j+1:n] - x(j) * A[j+1:n,j]
     end

Define bounds on the components of x after j iterations of the loop: M(j) = bound on x[1:j] G(j) = bound on x[j+1:n] Initially, let M(0) = 0 and G(0) = max{x(i), i=1,...,n}.

Then for iteration j+1 we have M(j+1) <= G(j) / | A(j+1,j+1) | G(j+1) <= G(j) + M(j+1) * | A[j+2:n,j+1] | <= G(j) ( 1 + CNORM(j+1) / | A(j+1,j+1) | )

where CNORM(j+1) is greater than or equal to the infinity-norm of column j+1 of A, not counting the diagonal. Hence

G(j) <= G(0) product ( 1 + CNORM(i) / | A(i,i) | ) 1 <= i <= j and

|x(j)| <= ( G(0) / |A(j,j)| ) product ( 1 + CNORM(i) / |A(i,i)| ) 1 <= i < j

Since |x(j)| <= M(j), we use the Level 2 BLAS routine ZTRSV if the reciprocal of the largest M(j), j=1,..,n, is larger than max(underflow, 1/overflow).

The bound on x(j) is also used to determine when a step in the columnwise method can be performed without fear of overflow. If the computed bound is greater than a large constant, x is scaled to prevent overflow, but if the bound overflows, x is set to 0, x(j) to 1, and scale to 0, and a non-trivial solution to A*x = 0 is found.

Similarly, a row-wise scheme is used to solve A**T *x = b or A**H *x = b. The basic algorithm for upper triangular A is:

     for j = 1, ..., n
          x(j) := ( b(j) - A[1:j-1,j]' * x[1:j-1] ) / A(j,j)
     end

We simultaneously compute two bounds G(j) = bound on ( b(i) - A[1:i-1,i]' * x[1:i-1] ), 1 <= i <= j M(j) = bound on x(i), 1 <= i <= j

The initial values are G(0) = 0, M(0) = max{b(i), i=1,..,n}, and we add the constraint G(j) >= G(j-1) and M(j) >= M(j-1) for j >= 1. Then the bound on x(j) is

     M(j) <= M(j-1) * ( 1 + CNORM(j) ) / | A(j,j) |

          <= M(0) * product      ( ( 1 + CNORM(i) ) / |A(i,i)| )
                    1 <= i <= j

and we can safely call ZTRSV if 1/M(n) and 1/G(n) are both greater than max(underflow, 1/overflow).